diff --git a/tests/test_hub/test_create_notification_block.py b/tests/test_hub/test_create_notification_block.py
new file mode 100644
index 0000000..278bf54
--- /dev/null
+++ b/tests/test_hub/test_create_notification_block.py
@@ -0,0 +1,161 @@
+import unittest
+import mock
+
+import koji
+import kojihub
+
+QP = kojihub.QueryProcessor
+IP = kojihub.InsertProcessor
+UP = kojihub.UpdateProcessor
+
+
+class TestCreateNotificationBlock(unittest.TestCase):
+    def getInsert(self, *args, **kwargs):
+        insert = IP(*args, **kwargs)
+        insert.execute = mock.MagicMock()
+        self.inserts.append(insert)
+        return insert
+
+    def getQuery(self, *args, **kwargs):
+        query = QP(*args, **kwargs)
+        query.execute = mock.MagicMock()
+        self.queries.append(query)
+        return query
+
+    def getUpdate(self, *args, **kwargs):
+        update = UP(*args, **kwargs)
+        update.execute = mock.MagicMock()
+        self.updates.append(update)
+        return update
+
+    def setUp(self):
+        self.context = mock.patch('kojihub.context').start()
+        self.context.opts = {
+            'EmailDomain': 'test.domain.com',
+            'NotifyOnSuccess': True,
+        }
+
+        self.QueryProcessor = mock.patch('kojihub.QueryProcessor',
+                                         side_effect=self.getQuery).start()
+        self.queries = []
+        self.InsertProcessor = mock.patch('kojihub.InsertProcessor',
+                                          side_effect=self.getInsert).start()
+        self.inserts = []
+        self.UpdateProcessor = mock.patch('kojihub.UpdateProcessor',
+                                          side_effect=self.getUpdate).start()
+        self.updates = []
+        self.get_tag_id = mock.patch('kojihub.get_tag_id').start()
+        self.get_package_id = mock.patch('kojihub.get_package_id').start()
+        self.get_build_notification_blocks = mock.patch(
+            'kojihub.get_build_notification_blocks').start()
+
+        self.exports = kojihub.RootExports()
+        self.exports.getLoggedInUser = mock.MagicMock()
+        self.exports.getUser = mock.MagicMock()
+        self.exports.hasPerm = mock.MagicMock()
+        self.cursor = mock.MagicMock()
+        self.user_id = 1
+        self.package_id = 555
+        self.tag_id = 111
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_createNotificationBlock(self):
+        self.exports.getLoggedInUser.return_value = {'id': 1}
+        self.exports.getUser.return_value = {'id': 2, 'name': 'username'}
+        self.exports.hasPerm.return_value = True
+        self.get_package_id.return_value = self.package_id
+        self.get_tag_id.return_value = self.tag_id
+        self.get_build_notification_blocks.return_value = []
+
+        r = self.exports.createNotificationBlock(self.user_id, self.package_id, self.tag_id)
+        self.assertEqual(r, None)
+
+        self.exports.getLoggedInUser.assert_called_once()
+        self.exports.getUser.asssert_called_once_with(self.user_id)
+        self.exports.hasPerm.asssert_called_once_with('admin')
+        self.get_package_id.assert_called_once_with(self.package_id, strict=True)
+        self.get_tag_id.assert_called_once_with(self.tag_id, strict=True)
+        self.get_build_notification_blocks.assert_called_once_with(2)
+        self.assertEqual(len(self.inserts), 1)
+        insert = self.inserts[0]
+        self.assertEqual(insert.table, 'build_notifications_block')
+        self.assertEqual(insert.data, {
+            'package_id': self.package_id,
+            'user_id': 2,
+            'tag_id': self.tag_id,
+        })
+        self.assertEqual(insert.rawdata, {})
+
+    def test_createNotificationBlock_unauthentized(self):
+        self.exports.getLoggedInUser.return_value = None
+
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.createNotificationBlock(self.user_id, self.package_id, self.tag_id)
+        self.assertEqual('Not logged-in', str(cm.exception))
+
+        self.assertEqual(len(self.inserts), 0)
+
+    def test_createNotificationBlock_invalid_user(self):
+        user_id = 2
+        self.exports.getLoggedInUser.return_value = {'id': 1}
+        self.exports.getUser.return_value = None
+
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.createNotificationBlock(user_id, self.package_id, self.tag_id)
+        self.assertEqual(f'No such user ID: {user_id}', str(cm.exception))
+
+        self.assertEqual(len(self.inserts), 0)
+
+    def test_createNotificationBlock_no_perm(self):
+        user_id = 2
+        self.exports.getLoggedInUser.return_value = {'id': 1, 'name': 'a'}
+        self.exports.getUser.return_value = {'id': 2, 'name': 'b'}
+        self.exports.hasPerm.return_value = False
+
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.createNotificationBlock(user_id, self.package_id, self.tag_id)
+        self.assertEqual('user a cannot create notification blocks for user b', str(cm.exception))
+
+        self.assertEqual(len(self.inserts), 0)
+
+    def test_createNotificationBlock_invalid_pkg(self):
+        user_id = 2
+        self.exports.getLoggedInUser.return_value = {'id': 2, 'name': 'a'}
+        self.exports.getUser.return_value = {'id': 2, 'name': 'a'}
+        self.get_package_id.side_effect = ValueError
+
+        with self.assertRaises(ValueError):
+            self.exports.createNotificationBlock(user_id, self.package_id, self.tag_id)
+
+        self.assertEqual(len(self.inserts), 0)
+
+    def test_createNotificationBlock_invalid_tag(self):
+        user_id = 2
+        self.exports.getLoggedInUser.return_value = {'id': 2, 'name': 'a'}
+        self.exports.getUser.return_value = {'id': 2, 'name': 'a'}
+        self.get_package_id.return_value = self.package_id
+        self.get_tag_id.side_effect = ValueError
+
+        with self.assertRaises(ValueError):
+            self.exports.createNotificationBlock(user_id, self.package_id, self.tag_id)
+
+        self.assertEqual(len(self.inserts), 0)
+
+    def test_createNotificationBlock_exists(self):
+        user_id = 2
+        self.exports.getLoggedInUser.return_value = {'id': 2, 'name': 'a'}
+        self.exports.getUser.return_value = {'id': 2, 'name': 'a'}
+        self.get_package_id.return_value = self.package_id
+        self.get_tag_id.return_value = self.tag_id
+        self.get_build_notification_blocks.return_value = [{
+            'package_id': self.package_id,
+            'tag_id': self.tag_id,
+        }]
+
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.createNotificationBlock(user_id, self.package_id, self.tag_id)
+        self.assertEqual('notification already exists', str(cm.exception))
+
+        self.assertEqual(len(self.inserts), 0)
diff --git a/tests/test_hub/test_create_tag.py b/tests/test_hub/test_create_tag.py
index 22e2777..e5498e8 100644
--- a/tests/test_hub/test_create_tag.py
+++ b/tests/test_hub/test_create_tag.py
@@ -24,8 +24,9 @@ class TestCreateTag(unittest.TestCase):
         self._dml = mock.patch('kojihub._dml').start()
         self.get_tag = mock.patch('kojihub.get_tag').start()
         self.get_tag_id = mock.patch('kojihub.get_tag_id').start()
+        self.get_perm_id = mock.patch('kojihub.get_perm_id').start()
         self.verify_name_internal = mock.patch('kojihub.verify_name_internal').start()
-        self.writeInheritanceData = mock.patch('kojihub.writeInheritanceData').start()
+        self.writeInheritanceData = mock.patch('kojihub._writeInheritanceData').start()
         self.context = mock.patch('kojihub.context').start()
         # It seems MagicMock will not automatically handle attributes that
         # start with "assert"
@@ -42,12 +43,13 @@ class TestCreateTag(unittest.TestCase):
             kojihub.create_tag('duptag')
 
     def test_simple_create(self):
-        self.get_tag.return_value = None
+        self.get_tag.side_effect = [None, {'id': 1, 'name': 'parent-tag'}]
         self.get_tag_id.return_value = 99
         self.verify_name_internal.return_value = None
         self.context.event_id = 42
         self.context.session.user_id = 23
-        kojihub.create_tag('newtag')
+        self.writeInheritanceData.return_value = None
+        kojihub.create_tag('newtag', parent='parent-tag')
 
         # check the insert
         self.assertEqual(len(self.inserts), 1)
@@ -97,3 +99,21 @@ class TestCreateTag(unittest.TestCase):
         self.verify_name_internal.side_effect = koji.GenericError
         with self.assertRaises(koji.GenericError):
             kojihub.create_tag(tag_name)
+
+    def test_tag_non_exist_parent(self):
+        parent_tag = 'parent-tag'
+        self.verify_name_internal.return_value = None
+        self.get_tag.side_effect = [None, None]
+        with self.assertRaises(koji.GenericError) as ex:
+            kojihub.create_tag('new-tag', parent=parent_tag)
+        self.assertEqual("Parent tag '%s' could not be found" % parent_tag, str(ex.exception))
+
+    def test_tag_not_maven_support(self):
+        self.verify_name_internal.return_value = None
+        self.context.opts.get.return_value = False
+        with self.assertRaises(koji.GenericError) as ex:
+            kojihub.create_tag('new-tag', maven_support=True)
+        self.assertEqual("Maven support not enabled", str(ex.exception))
+        with self.assertRaises(koji.GenericError) as ex:
+            kojihub.create_tag('new-tag', maven_include_all=True)
+        self.assertEqual("Maven support not enabled", str(ex.exception))
diff --git a/tests/test_hub/test_create_user.py b/tests/test_hub/test_create_user.py
index 2ba9f33..d991aa8 100644
--- a/tests/test_hub/test_create_user.py
+++ b/tests/test_hub/test_create_user.py
@@ -38,19 +38,27 @@ class TestCreateUser(unittest.TestCase):
             self.exports.createUser(user_name)
 
     def test_create_user_exists(self):
-        expected = 'user already exists: %s' % self.user_name
         self.verify_name_user.return_value = None
         self.get_user.return_value = self.user_info
         with self.assertRaises(koji.GenericError) as cm:
             self.exports.createUser(self.user_name)
-        self.assertEqual(expected, str(cm.exception))
+        self.assertEqual(f"user already exists: {self.user_name}", str(cm.exception))
 
     def test_create_user_exists_krb(self):
         krb_principal = 'test_user@fedora.org'
-        expected = 'user with this Kerberos principal already exists: %s' % krb_principal
+        expected = f"user with this Kerberos principal already exists: {krb_principal}"
         self.verify_name_user.return_value = None
         self.get_user.return_value = None
         self.get_user_by_krb_principal.return_value = self.user_info_krb
         with self.assertRaises(koji.GenericError) as cm:
             self.exports.createUser(self.user_name, krb_principal=krb_principal)
         self.assertEqual(expected, str(cm.exception))
+
+    def test_create_user_wrong_type_status(self):
+        status = 'test-status'
+        self.verify_name_user.return_value = None
+        self.get_user.return_value = None
+        self.get_user_by_krb_principal.return_value = self.user_info_krb
+        with self.assertRaises(koji.ParameterError) as cm:
+            self.exports.createUser(self.user_name, status=status)
+        self.assertEqual(f"Invalid type for value '{status}': {type(status)}", str(cm.exception))
diff --git a/tests/test_hub/test_delete_notification.py b/tests/test_hub/test_delete_notification.py
new file mode 100644
index 0000000..90da193
--- /dev/null
+++ b/tests/test_hub/test_delete_notification.py
@@ -0,0 +1,103 @@
+import mock
+import unittest
+
+import koji
+import kojihub
+
+QP = kojihub.QueryProcessor
+IP = kojihub.InsertProcessor
+UP = kojihub.UpdateProcessor
+
+
+class TestDeleteNotifications(unittest.TestCase):
+    def getInsert(self, *args, **kwargs):
+        insert = IP(*args, **kwargs)
+        insert.execute = mock.MagicMock()
+        self.inserts.append(insert)
+        return insert
+
+    def getQuery(self, *args, **kwargs):
+        query = QP(*args, **kwargs)
+        query.execute = mock.MagicMock()
+        self.queries.append(query)
+        return query
+
+    def getUpdate(self, *args, **kwargs):
+        update = UP(*args, **kwargs)
+        update.execute = mock.MagicMock()
+        self.updates.append(update)
+        return update
+
+    def setUp(self):
+        self.context = mock.patch('kojihub.context').start()
+        self.context.opts = {
+            'EmailDomain': 'test.domain.com',
+            'NotifyOnSuccess': True,
+        }
+
+        self.QueryProcessor = mock.patch('kojihub.QueryProcessor',
+                                         side_effect=self.getQuery).start()
+        self.queries = []
+        self.InsertProcessor = mock.patch('kojihub.InsertProcessor',
+                                          side_effect=self.getInsert).start()
+        self.inserts = []
+        self.UpdateProcessor = mock.patch('kojihub.UpdateProcessor',
+                                          side_effect=self.getUpdate).start()
+        self.updates = []
+        self._dml = mock.patch('kojihub._dml').start()
+
+        self.exports = kojihub.RootExports()
+        self.exports.getLoggedInUser = mock.MagicMock()
+        self.exports.hasPerm = mock.MagicMock()
+        self.exports.getBuildNotification = mock.MagicMock()
+        self.user_id = 752
+        self.n_id = 543
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_deleteNotification(self):
+        self.exports.getBuildNotification.return_value = {'user_id': self.user_id}
+
+        self.exports.deleteNotification(self.n_id)
+
+        self.exports.getBuildNotification.assert_called_once_with(self.n_id, strict=True)
+        self.exports.getLoggedInUser.assert_called_once_with()
+        self._dml.assert_called_once()
+
+    def test_deleteNotification_missing(self):
+        self.exports.getBuildNotification.side_effect = koji.GenericError
+
+        with self.assertRaises(koji.GenericError):
+            self.exports.deleteNotification(self.n_id)
+
+        self.exports.getBuildNotification.assert_called_once_with(self.n_id, strict=True)
+
+    def test_deleteNotification_not_logged(self):
+        self.exports.getBuildNotification.return_value = {'user_id': self.user_id}
+        self.exports.getLoggedInUser.return_value = None
+        # self.set_queries = ([
+        #    [{'user_id': 5, 'email': 'owner_name@%s' % self.context.opts['EmailDomain']}],
+        # ])
+
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.deleteNotification(self.n_id)
+        self.assertEqual('Not logged-in', str(cm.exception))
+
+        self.exports.getBuildNotification.assert_called_once_with(self.n_id, strict=True)
+        self.assertEqual(len(self.inserts), 0)
+        self.assertEqual(len(self.updates), 0)
+        self.assertEqual(len(self.queries), 0)
+
+    def test_deleteNotification_no_perm(self):
+        self.exports.getBuildNotification.return_value = {'user_id': self.user_id}
+        self.exports.getLoggedInUser.return_value = {'id': 1}
+        self.exports.hasPerm.return_value = False
+
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.deleteNotification(self.n_id)
+        self.assertEqual(f'user 1 cannot delete notifications for user {self.user_id}',
+                         str(cm.exception))
+
+        self.exports.getBuildNotification.assert_called_once_with(self.n_id, strict=True)
+        self._dml.assert_not_called()
diff --git a/tests/test_hub/test_delete_notification_block.py b/tests/test_hub/test_delete_notification_block.py
new file mode 100644
index 0000000..5f5379b
--- /dev/null
+++ b/tests/test_hub/test_delete_notification_block.py
@@ -0,0 +1,104 @@
+import mock
+import unittest
+
+import koji
+import kojihub
+
+QP = kojihub.QueryProcessor
+IP = kojihub.InsertProcessor
+UP = kojihub.UpdateProcessor
+
+
+class TestDeleteNotificationsBlocks(unittest.TestCase):
+    def getInsert(self, *args, **kwargs):
+        insert = IP(*args, **kwargs)
+        insert.execute = mock.MagicMock()
+        self.inserts.append(insert)
+        return insert
+
+    def getQuery(self, *args, **kwargs):
+        query = QP(*args, **kwargs)
+        query.execute = mock.MagicMock()
+        self.queries.append(query)
+        return query
+
+    def getUpdate(self, *args, **kwargs):
+        update = UP(*args, **kwargs)
+        update.execute = mock.MagicMock()
+        self.updates.append(update)
+        return update
+
+    def setUp(self):
+        self.context = mock.patch('kojihub.context').start()
+        self.context.opts = {
+            'EmailDomain': 'test.domain.com',
+            'NotifyOnSuccess': True,
+        }
+
+        self.QueryProcessor = mock.patch('kojihub.QueryProcessor',
+                                         side_effect=self.getQuery).start()
+        self.queries = []
+        self.InsertProcessor = mock.patch('kojihub.InsertProcessor',
+                                          side_effect=self.getInsert).start()
+        self.inserts = []
+        self.UpdateProcessor = mock.patch('kojihub.UpdateProcessor',
+                                          side_effect=self.getUpdate).start()
+        self.updates = []
+        self.get_user = mock.patch('kojihub.get_user').start()
+        self._dml = mock.patch('kojihub._dml').start()
+
+        self.exports = kojihub.RootExports()
+        self.exports.getLoggedInUser = mock.MagicMock()
+        self.exports.hasPerm = mock.MagicMock()
+        self.exports.getBuildNotificationBlock = mock.MagicMock()
+        self.user_id = 752
+        self.n_id = 543
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_deleteNotificationBlock(self):
+        self.exports.getBuildNotificationBlock.return_value = {'user_id': self.user_id}
+
+        self.exports.deleteNotificationBlock(self.n_id)
+
+        self.exports.getBuildNotificationBlock.assert_called_once_with(self.n_id, strict=True)
+        self.exports.getLoggedInUser.assert_called_once_with()
+        self._dml.assert_called_once()
+
+    def test_deleteNotificationBlock_missing(self):
+        self.exports.getBuildNotificationBlock.side_effect = koji.GenericError
+
+        with self.assertRaises(koji.GenericError):
+            self.exports.deleteNotificationBlock(self.n_id)
+
+        self.exports.getBuildNotificationBlock.assert_called_once_with(self.n_id, strict=True)
+
+    def test_deleteNotificationBlock_not_logged(self):
+        self.exports.getBuildNotificationBlock.return_value = {'user_id': self.user_id}
+        self.exports.getLoggedInUser.return_value = None
+        # self.set_queries = ([
+        #    [{'user_id': 5, 'email': 'owner_name@%s' % self.context.opts['EmailDomain']}],
+        # ])
+
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.deleteNotificationBlock(self.n_id)
+        self.assertEqual('Not logged-in', str(cm.exception))
+
+        self.exports.getBuildNotificationBlock.assert_called_once_with(self.n_id, strict=True)
+        self.assertEqual(len(self.inserts), 0)
+        self.assertEqual(len(self.updates), 0)
+        self.assertEqual(len(self.queries), 0)
+
+    def test_deleteNotificationBlock_no_perm2(self):
+        self.exports.getBuildNotificationBlock.return_value = {'user_id': self.user_id}
+        self.exports.getLoggedInUser.return_value = {'id': 1}
+        self.exports.hasPerm.return_value = False
+
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.deleteNotificationBlock(self.n_id)
+        self.assertEqual(f'user 1 cannot delete notification blocks for user {self.user_id}',
+                         str(cm.exception))
+
+        self.exports.getBuildNotificationBlock.assert_called_once_with(self.n_id, strict=True)
+        self._dml.assert_not_called()
diff --git a/tests/test_hub/test_disable_channel.py b/tests/test_hub/test_disable_channel.py
index 61e28d6..3d967ac 100644
--- a/tests/test_hub/test_disable_channel.py
+++ b/tests/test_hub/test_disable_channel.py
@@ -28,7 +28,13 @@ class TestDisableChannel(unittest.TestCase):
         self.get_channel.return_value = None
         with self.assertRaises(koji.GenericError) as cm:
             self.exports.disableChannel(self.channelname)
-        self.assertEqual("No such channel: %s" % self.channelname, str(cm.exception))
+        self.assertEqual(f"No such channel: {self.channelname}", str(cm.exception))
+
+    def test_wrong_type_channel(self):
+        comment = ['test-comment']
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.disableChannel(self.channelname, comment=comment)
+        self.assertEqual(f"Invalid type for value '{comment}': {type(comment)}", str(cm.exception))
 
     def test_valid(self):
         self.get_channel.return_value = {'comment': None, 'description': None,
diff --git a/tests/test_hub/test_dist_repo.py b/tests/test_hub/test_dist_repo.py
index 9ba1be0..40b69e1 100644
--- a/tests/test_hub/test_dist_repo.py
+++ b/tests/test_hub/test_dist_repo.py
@@ -31,6 +31,7 @@ class TestDistRepoInit(unittest.TestCase):
         self.get_event = mock.patch('kojihub.get_event').start()
         self.nextval = mock.patch('kojihub.nextval').start()
         self.copyfile = mock.patch('shutil.copyfile').start()
+        self.lookup_name = mock.patch('kojihub.lookup_name').start()
 
         self.get_tag.return_value = {'id': 42, 'name': 'tag'}
         self.get_event.return_value = 12345
@@ -70,6 +71,34 @@ class TestDistRepoInit(unittest.TestCase):
 
         self.copyfile.assert_called_once()
 
+    def test_simple_dist_repo_init_wrong_type_keys(self):
+        keys = 'key1 key2'
+        with self.assertRaises(koji.ParameterError) as cm:
+            kojihub.dist_repo_init('tag', keys, {'arch': ['x86_64']})
+        self.assertEqual(f"Invalid type for value '{keys}': {type(keys)}", str(cm.exception))
+        self.InsertProcessor.assert_not_called()
+
+    def test_simple_dist_repo_init_wrong_type_task_opts(self):
+        task_opts = 'opts'
+        with self.assertRaises(koji.ParameterError) as cm:
+            kojihub.dist_repo_init('tag', ['key'], task_opts)
+        self.assertEqual(f"Invalid type for value '{task_opts}': {type(task_opts)}",
+                         str(cm.exception))
+        self.InsertProcessor.assert_not_called()
+
+    def test_simple_dist_repo_init_wrong_type_event(self):
+        event = 'test-event'
+        with self.assertRaises(koji.ParameterError) as cm:
+            kojihub.dist_repo_init('tag', ['key'], {'arch': ['x86_64'], 'event': event})
+        self.assertEqual(f"Invalid type for value '{event}': {type(event)}", str(cm.exception))
+        self.InsertProcessor.assert_not_called()
+
+    def test_simple_dist_repo_init_wrong_type_volume(self):
+        self.lookup_name.side_effect = koji.GenericError
+        with self.assertRaises(koji.GenericError):
+            kojihub.dist_repo_init('tag', ['key'], {'arch': ['x86_64'], 'volume': 'test-volume'})
+        self.InsertProcessor.assert_not_called()
+
 
 class TestDistRepo(unittest.TestCase):
 
@@ -206,7 +235,7 @@ class TestDistRepoMove(unittest.TestCase):
             path = os.path.join(repodir, relpath)
             basename = os.path.basename(path)
             if not os.path.exists(path):
-                raise Exception("Missing file: %s" % path)
+                raise Exception(f"Missing file: {path}")
             data = open(path, 'rt', encoding='utf-8').read()
             data.strip()
             self.assertEqual(data, basename)
diff --git a/tests/test_hub/test_download_task_output.py b/tests/test_hub/test_download_task_output.py
new file mode 100644
index 0000000..d7c9c74
--- /dev/null
+++ b/tests/test_hub/test_download_task_output.py
@@ -0,0 +1,36 @@
+import mock
+import unittest
+import koji
+import kojihub
+
+
+class TestDownloadTaskOutput(unittest.TestCase):
+
+    def setUp(self):
+        self.exports = kojihub.RootExports()
+        self.exports.getVolume = mock.MagicMock()
+        self.task_id = 1
+        self.filename = 'test-file'
+        self.volumename = 'test-volume'
+
+    def tearDown(self):
+        mock.patch.stopall()
+
+    def test_size_wrong_type(self):
+        size = 'test-size'
+        with self.assertRaises(koji.ParameterError) as cm:
+            self.exports.downloadTaskOutput(self.task_id, self.filename, size=size)
+        self.assertEqual(f"Invalid type for value '{size}': {type(size)}", str(cm.exception))
+
+    def test_volume_non_exist_wrong_type(self):
+        self.exports.getVolume.side_effect = koji.GenericError
+        with self.assertRaises(koji.GenericError):
+            self.exports.downloadTaskOutput(self.task_id, self.filename, volume=self.volumename)
+
+    def test_filename_wrong_format(self):
+        filename = '../test-file'
+        volumeinfo = {'id': 1, 'name': self.volumename}
+        self.exports.getVolume.return_value = volumeinfo
+        with self.assertRaises(koji.GenericError) as cm:
+            self.exports.downloadTaskOutput(self.task_id, filename, volume=self.volumename)
+        self.assertEqual(f"Invalid file name: {filename}", str(cm.exception))
